pub mod graceful_shutdown;
pub mod http_serde;
pub mod prelude;

// It's easier if the server can stream its response body
// back to the relay un-changed inside its request body
// So we wrap the server's actual response head
// (status code, headers, etc.) in this one header field.

pub const PTTH_MAGIC_HEADER: &str = "X-PTTH-2LJYXWC4";

// The arguments are in order so they are in order overall:
// e.g. prefix_match ("/prefix", "/prefix/middle/suffix") -> "/middle/suffix"

pub fn prefix_match <'a> (prefix: &str, hay: &'a str) -> Option <&'a str>
{
	if hay.starts_with (prefix) {
		Some (&hay [prefix.len ()..])
	}
	else {
		None
	}
}
